module.exports = (function() {
var __MODS__ = {};
var __DEFINE__ = function(modId, func, req) { var m = { exports: {}, _tempexports: {} }; __MODS__[modId] = { status: 0, func: func, req: req, m: m }; };
var __REQUIRE__ = function(modId, source) { if(!__MODS__[modId]) return require(source); if(!__MODS__[modId].status) { var m = __MODS__[modId].m; m._exports = m._tempexports; var desp = Object.getOwnPropertyDescriptor(m, "exports"); if (desp && desp.configurable) Object.defineProperty(m, "exports", { set: function (val) { if(typeof val === "object" && val !== m._exports) { m._exports.__proto__ = val.__proto__; Object.keys(val).forEach(function (k) { m._exports[k] = val[k]; }); } m._tempexports = val }, get: function () { return m._tempexports; } }); __MODS__[modId].status = 1; __MODS__[modId].func(__MODS__[modId].req, m, m.exports); } return __MODS__[modId].m.exports; };
var __REQUIRE_WILDCARD__ = function(obj) { if(obj && obj.__esModule) { return obj; } else { var newObj = {}; if(obj != null) { for(var k in obj) { if (Object.prototype.hasOwnProperty.call(obj, k)) newObj[k] = obj[k]; } } newObj.default = obj; return newObj; } };
var __REQUIRE_DEFAULT__ = function(obj) { return obj && obj.__esModule ? obj.default : obj; };
__DEFINE__(1638703868284, function(require, module, exports) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
Object.defineProperty(exports, "createParser", {
  enumerable: true,
  get: function get() {
    return _createParser["default"];
  }
});
exports.parsers = exports["default"] = void 0;

var _objToString = _interopRequireDefault(require("./objToString"));

var _createParser = _interopRequireDefault(require("./createParser"));

var parsers = _interopRequireWildcard(require("./parsers"));

exports.parsers = parsers;

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj["default"] = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var _default = _objToString["default"];
exports["default"] = _default;
module.exports = _objToString["default"];
module.exports.createParser = _createParser["default"];
module.exports.parsers = _objectSpread({}, parsers);
}, function(modId) {var map = {"./objToString":1638703868285,"./createParser":1638703868287,"./parsers":1638703868286}; return __REQUIRE__(map[modId], modId); })
__DEFINE__(1638703868285, function(require, module, exports) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _parsers = require("./parsers");

function objToString(styleObj, parser = _parsers.camelToKebab) {
  if (!styleObj || typeof styleObj !== 'object' || Array.isArray(styleObj)) {
    throw new TypeError("expected an argument of type object, but got ".concat(typeof styleObj));
  }

  const lines = Object.keys(styleObj).map(property => "".concat(parser(property), ": ").concat(styleObj[property], ";"));
  return lines.join('\n');
}

var _default = objToString;
exports["default"] = _default;
}, function(modId) { var map = {"./parsers":1638703868286}; return __REQUIRE__(map[modId], modId); })
__DEFINE__(1638703868286, function(require, module, exports) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.snakeToKebab = exports.camelToKebab = void 0;

var _createParser = _interopRequireDefault(require("./createParser"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

const camelToKebab = (0, _createParser["default"])(/[A-Z]/, match => "-".concat(match.toLowerCase()));
exports.camelToKebab = camelToKebab;
const snakeToKebab = (0, _createParser["default"])(/_/, () => '-'); // disabled to allow named exports while only one named export exists
// eslint-disable-next-line

exports.snakeToKebab = snakeToKebab;
}, function(modId) { var map = {"./createParser":1638703868287}; return __REQUIRE__(map[modId], modId); })
__DEFINE__(1638703868287, function(require, module, exports) {


Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

function createParser(matcher, replacer) {
  const regex = RegExp(matcher, 'g');
  return string => {
    // * throw an error if not a string
    if (typeof string !== 'string') {
      throw new TypeError("expected an argument of type string, but got ".concat(typeof styleObj));
    } // * if no match between string and matcher


    if (!string.match(regex)) {
      return string;
    } // * executes the replacer function for each match
    // ? replacer can take any arguments valid for String.prototype.replace


    return string.replace(regex, replacer);
  };
}

var _default = createParser;
exports["default"] = _default;
}, function(modId) { var map = {}; return __REQUIRE__(map[modId], modId); })
return __REQUIRE__(1638703868284);
})()
//miniprogram-npm-outsideDeps=[]
//# sourceMappingURL=index.js.map